//: C07:RawStorageIterator.cpp {-bor}
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// demonstruje raw_storage_iterator.
//{L} Noisy
#include <iostream>
#include <iterator>
#include <algorithm>
#include "Noisy.h"
using namespace std;

int main() {
  const int MNOZSTVI = 10;
  // Vytvořit neformátované úložiště a přetypovat je na požadovaný typ:
  Noisy* np = reinterpret_cast<Noisy*>(
    new char[MNOZSTVI * sizeof(Noisy)]);
  raw_storage_iterator<Noisy*, Noisy> rsi(np);
  for(int i = 0; i < MNOZSTVI; i++)
    *rsi++ = Noisy(); // Umístit objekty do úložiště
  cout << endl;
  copy(np, np + MNOZSTVI,
    ostream_iterator<Noisy>(cout, " "));
  cout << endl;
  // uklidit explicitním voláním destruktoru:
  for(int j = 0; j < MNOZSTVI; j++)
    (&np[j])->~Noisy();
  // uvolnit neformátované úložiště:
  delete reinterpret_cast<char*>(np);
} ///:~
